function MPC=ModelPredictiveControl(n,m,Nu,tf,Dt,X0,Xd,Umax,P0,Vo,Ro,Rr,No,Rsafe,RobotParameters,CaseNumber)
X(:,1)=X0;
t(1)=0;
kf=fix(tf/Dt);
Up=zeros(1,Nu*m);
U(:,1)=zeros(m,1);
RealTime=[0];
RealX=X0';
RealDX=zeros(1,3);
RealU=U';
RealErr=X0'-Xd';
for i=1:No
    Reald_r_o(i)=norm(P0(i,:)-X0(1:2)')-Ro(i)-Rr;
end
Uub=Umax*ones(1,Nu*m);Ulb=-Umax*ones(1,Nu*m);
OptTime(1)=0;
%**********************************************************************
for k=2:kf
    InitialUp=Up;
    t(k)=(k-1)*Dt;
    Options = optimoptions(@fmincon,'Algorithm','sqp','Display','off','Useparallel',true,'TolCon',1e-6);%,'PlotFcns',@optimplotfval);
    t1=cputime;
    [Up,Fval]=fmincon(@ObjectiveFuction,InitialUp,[],[],[],[],Ulb,Uub,@NonlinearConstraints,Options);
    t2=cputime;
    OptTime(k)=t2-t1;
    U(:,k)=Up(1,1:m)';
    Cost(k)=Fval;
    Up=[Up(m+1:Nu*m) zeros(1,m)];
    [Time,Z]=ode113(@(tt,q) PlantWithFriction(tt,q,U(:,k),RobotParameters),[t(k-1) t(k)],X(:,k-1));
    L=length(Time);
    X(:,k)=Z(L,:);
    clear RDX uu RErr d_r_o
    for h=1:length(Time)
        Pobs=P0+Time(h)*Vo;
        for jj=1:No
            d_r_o(h,jj)=norm(Pobs(jj,:)-Z(h,1:2))-Ro(jj)-.15;
        end
        Slope=(U(:,k-1)-U(:,k))/(t(k-1)-t(k));
        RErr(h,:)=Z(h,:)-Xd';
        uu(h,:)=Slope'*(Time(h)-t(k-1))+U(:,k-1)';
    end
    Reald_r_o=[Reald_r_o;d_r_o];
    RealTime=[RealTime;Time];
    RealX=[RealX;Z];
    RealErr=[RealErr;RErr];
    RealU=[RealU;uu];
    disp([num2str(fix(k*100/kf)) '%']);
end
MPC{1}=[t(1:kf);X(:,1:kf);Cost;U;OptTime];
MPC{2}=RealTime;
MPC{3}=RealX;
MPC{5}=RealU;
MPC{6}=RealErr;
MPC{7}=Reald_r_o;
%*********************************************************************
    function J=ObjectiveFuction(Input)
        for s=1:Nu
            ControlInput(:,s)=Input(1,(s-1)*m+1:s*m)';
        end
        PreviousX=X(:,k-1);
        Uold=U(:,k-1);
        for s=1:Nu
            if s==1
                Us=U(:,k-1);
            else
                Us=ControlInput(:,s-1);
            end
            Xp(:,s)=PreviousX+PlantWithFriction(0,PreviousX,ControlInput(:,s),RobotParameters)*Dt;
            PreviousX=Xp(:,s);
        end
        Sum2=0;
        Sum=StageCost1(X(:,k-1),Xd);
        for s=1:Nu-1
            Sum=Sum+StageCost1(Xp(:,s),Xd);
            Sum2=Sum2+norm(ControlInput(:,s),2)^2;
        end 
        Sum2=Sum2+norm(ControlInput(:,Nu),2)^2;
        J=Sum+1e8*StageCost1(Xp(:,Nu),Xd)+1*Sum2;
    end
%********************************************************************
   function [C Ceq]=NonlinearConstraints(Input) 
       for s=1:Nu
            ControlInput(:,s)=Input(1,(s-1)*m+1:s*m)';
        end
        PreviousX=X(:,k-1);
        Uold=U(:,k-1);
        for s=1:Nu
            if s==1
                Us=U(:,k-1);
            else
                Us=ControlInput(:,s-1);
            end
            Xp(:,s)=PreviousX+PlantWithFriction(0,PreviousX,ControlInput(:,s),RobotParameters)*Dt;
            PreviousX=Xp(:,s);
        end
        Po0=P0+(t(k)).*Vo;
        Index=1;
        for s=1:Nu
            Po=P0+(t(k)+s*Dt).*Vo;
            ConstraintsMaterials=Constraints(Xp(:,s),Po,Vo,Ro,Rr,No,Rsafe);
            for w=1:No
                if  norm(Po0(w,:)'-X(1:2,k-1))-Ro(w)-Rr<=1 
                    C(Index)=min(-ConstraintsMaterials(w,3)+ConstraintsMaterials(w,2),ConstraintsMaterials(w,3)-ConstraintsMaterials(w,1));
                    if max(C)==0
                        AS=5;
                    end
                    if imag(C(Index))~=0 
                        C(Index)=abs(imag(C(Index)));
                    end
                    Index=Index+1;
                end 
            end
        end
        for s=1:Nu
           [Xmin,Ymin,Xmax,Ymax]=P_min_max(Xp(1:2,s),CaseNumber);
           C(Index)=Xp(1,s)+Rr/2-Xmax;
           Index=Index+1;
           C(Index)=-(Xp(1,s)-Rr/2)+Xmin;
           Index=Index+1;
           C(Index)=Xp(2,s)+Rr/2-Ymax;
           Index=Index+1;
           C(Index)=-(Xp(2,s)-Rr/2)+Ymin;
           Index=Index+1;
        end
        Ceq=[];
    end
end

