clear
clc
syms Rrol Rwheel W1 W2 W3 W4 Beta DBeta Phi DT1 DT2 DT3 DT4 Phi DX DY DSay D2X D2Y D2Beta L H  real
syms DW1 DW2 DW3 DW4 Wr1 Wr2 Wr3 Wr4 DWr1 DWr2 DWr3 DWr4 real
syms Ipx Ipxy Ipxz Ipxy Ipy Ipyz Ipxz Ipyz Ipz Iwx Iwy Irx Iry real
syms T1 T2 T3 T4 Mp Mw Mr Muf1 Muf2 Muf3 Muf4 real
%***************************Robot Kinematic********************************
%
%**************************Platform Velocity*******************************
VG_1=[DX;DY;0];
R2_1=[cos(Beta) -sin(Beta) 0;sin(Beta) cos(Beta) 0;0 0 1];
R1_2=R2_1';
VG_2=R1_2*VG_1;
% VG_2=[DX;DY;0];
W_pf_2=[0;0;DBeta];
%*************************Wheels Linear Velocity***************************
rAi_G_2=[L L -L -L;H -H H -H;0 0 0 0];
for i=1:4
    VA_2(:,i)=VG_2+cross(W_pf_2,rAi_G_2(:,i));
end
%************************Rollers' Angular Velocity*************************
Wrol=[Wr1 Wr2 Wr3 Wr4];
Phi_rol=[-Phi Phi Phi -Phi];
for i=1:4
    Wr=Wrol(i);
    Wr_3(:,i)=[0;Wr;DBeta];
    R3_2=[cos(Phi_rol(i)) -sin(Phi_rol(i)) 0;sin(Phi_rol(i)) cos(Phi_rol(i)) 0;0 0 1];
    Wr_2(:,i)=simplify(R3_2*Wr_3(:,i));
end
%**********************Rollers' Pivot Linear Velocity**********************
Wwheel=[W1 W2 W3 W4];
for i=1:4
    VP_2_1(:,i)=VA_2(:,i)-[Rwheel*Wwheel(i);0;0];
end
for i=1:4
%     VP_2_2(:,i)=[Rrol*(DT(i)+Wwheel(i))*sin(Gama(i));-Rrol*(DT(i)+Wwheel(i))*cos(Gama(i));0];
    VP_2_2(:,i)=cross(Wr_2(:,i),[0;0;Rrol]);
end
%**************Velocity Analysis and Jacobian Determination****************
c=1;
for i=1:4
    Eq(c,1)=VP_2_1(1,i)-VP_2_2(1,i);
    c=c+1;
    Eq(c,1)=VP_2_1(2,i)-VP_2_2(2,i);
    c=c+1;
end
Answer=solve(Eq,[Wr1,Wr2,Wr3,Wr4,W1,W2,W3,W4]);
W=[Answer.W1;Answer.W2;Answer.W3;Answer.W4];
clear Wr
Wr=[Answer.Wr1;Answer.Wr2;Answer.Wr3;Answer.Wr4];
Jw=jacobian(W,[DX;DY;DBeta]);
Jdt=jacobian(Wr,[DX;DY;DBeta]);
VP_2_1=simplify(subs(VP_2_1,[W1 W2 W3 W4],[W(1) W(2) W(3) W(4)]));
%*************************Wheels Angular Velocity***************************
Ww_2=simplify([0 0 0 0;W(1) W(2) W(3) W(4);DBeta DBeta DBeta DBeta]);
for i=1:4
    Ww_1(:,i)=simplify(R2_1*Ww_2(:,i));
end
%********************Roller and Wheel Velocity Update**********************
Wr_2=simplify(subs(Wr_2,[Wr1 Wr2 Wr3 Wr4],[Wr(1) Wr(2) Wr(3) Wr(4)]));
VP_2_1=simplify(subs(VP_2_1,[W1 W2 W3 W4],[W(1) W(2) W(3) W(4)]));

%***************************Acceleration Analysis**************************
%
%*****************Platform Linear and Angular Acceleration*****************
aG_1=[D2X;D2Y;0];
aG_2=R1_2*aG_1;
Alpha_pf_2=[0;0;D2Beta];
%***********************Wheels' Linear Acceleration************************
for i=1:4
    aA_2(:,i)=diff(VA_2(:,i),DX)*D2X+diff(VA_2(:,i),DY)*D2Y+diff(VA_2(:,i),Beta)*DBeta+diff(VA_2(:,i),DBeta)*D2Beta+cross(W_pf_2,VA_2(:,i));
end
%***********************Wheels' Angular Acceleration***********************
for i=1:4
    DWw_2(:,i)=simplify(diff(Ww_2(:,i),DX)*D2X+diff(Ww_2(:,i),DY)*D2Y+diff(Ww_2(:,i),Beta)*DBeta+diff(Ww_2(:,i),DBeta)*D2Beta+cross(W_pf_2,Ww_2(:,i)));
    DWw_1(:,i)=simplify(diff(Ww_1(:,i),DX)*D2X+diff(Ww_1(:,i),DY)*D2Y+diff(Ww_1(:,i),Beta)*DBeta+diff(Ww_1(:,i),DBeta)*D2Beta);
end
%**********************Rollers' Linear Acceleration************************
for i=1:4
    aP_2(:,i)=diff(VP_2_1(:,i),DX)*D2X+diff(VP_2_1(:,i),DY)*D2Y+diff(VP_2_1(:,i),Beta)*DBeta+diff(VP_2_1(:,i),DBeta)*D2Beta+cross(W_pf_2,VP_2_1(:,i));
end
%**********************Rollers' Angular Acceleration***********************
for i=1:4
    DWr_2(:,i)=diff(Wr_2(:,i),DX)*D2X+diff(Wr_2(:,i),DY)*D2Y+diff(Wr_2(:,i),Beta)*DBeta+diff(Wr_2(:,i),DBeta)*D2Beta+cross(W_pf_2,Wr_2(:,i));
end
%**************************************************************************
%****************************Robot Dynamics********************************
%**************************Start Kane's Method*****************************
%**********************Define Generalized Velocity*************************
U=[DX DY DBeta]';
%**************************Velocity Unification****************************
%
%   Bodies: 1) Platform, 2)Wheel1, 3)Wheel2, 4)wheel3, 5)Wheel4
%        Bodies: 6) Roller1, 7)Roller2, 8)Roller3, 9)Roller4
%        V_2(Vector , BodyNumber) , W_2(Vector , BodyNumber)
%
%**************************************************************************
V_2(:,1)=VG_2;                          %Platform Velocity
for i=2:5
    V_2(:,i)=VA_2(:,i-1);               % Wheels' Velocity
    V_2(:,i+4)= VP_2_1(:,i-1);          % Rollers' Velocity
end
W_2(:,1)=W_pf_2;                        %Platform Angular Velocity
for i=2:5
    W_2(:,i)=Ww_2(:,i-1);               % Wheels' Angular Velocity
    W_2(:,i+4)= Wr_2(:,i-1);            % Rollers' Angular Velocity    
end
%**********************Acceleration Unification****************************
%
%   Bodies: 1) Platform, 2)Wheel1, 3)Wheel2, 4)wheel3, 5)Wheel4
%        Bodies: 6) Roller1, 7)Roller2, 8)Roller3, 9)Roller4
%        a_2(Vector , BodyNumber) , DW_2(Vector , BodyNumber)
%
%**************************************************************************
a_2(:,1)=aG_2;
for i=2:5
    a_2(:,i)=aA_2(:,i-1);               % Wheels' Acceleration
    a_2(:,i+4)= aP_2(:,i-1);          % Rollers' Acceleration
end
DW_2and3(:,1)=Alpha_pf_2;
for i=2:5
    R3_2=[cos(Phi_rol(i-1)) -sin(Phi_rol(i-1)) 0;sin(Phi_rol(i-1)) cos(Phi_rol(i-1)) 0;0 0 1];
    R2_3=R3_2';
    DW_2and3(:,i)=DWw_2(:,i-1);               % Wheels' Angular Velocity
    DW_2and3(:,i+4)= R2_3*DWr_2(:,i-1);            % Rollers' Angular Velocity    
end

%**************Calculate Partial Linear & Angular Velocities***************
%
%              V_par_2(Vector , BodyNumber , VelocityNumber)
%              W_par_2(Vector , BodyNumber , VelocityNumber)
%
%**************************************************************************
for i=1:9                       % Body Number
    for j=1:3                   % Generalized Velocity Number
        V_par_2(:,i,j)=simplify(diff(V_2(:,i),U(j)));
        W_par_2(:,i,j)=simplify(diff(W_2(:,i),U(j)));
    end
end
%
%********************Define Relative Angular Velocities********************
%
for i=1:4
    W_rel_2(:,i)=[0;W(i);0];
end
%
%*****************Define Partial Relative Angular Velocities***************
%  W_rel_par_2(Vector , RelativeVelocityNumber ,GeneralizedVelocityNumber)
%
for i=1:4
    for j=1:3
        W_rel_par_2(:,i,j)=simplify(diff(W_rel_2(:,i),U(j)));
    end
end
%
%******************************Define Mass*********************************
%
%                              M(BodyNumber)
%
M(1)=Mp;M(2)=Mw;M(3)=Mw;M(4)=Mw;M(5)=Mw;M(6)=Mr;M(7)=Mr;M(8)=Mr;M(9)=Mr;
%**********************Define Moment of Inertias***************************
%
%                     I(Row , Column , BodyNumber)
%
I_2(:,:,1)=[Ipx Ipxy Ipxz;Ipxy Ipy Ipyz;Ipxz Ipyz Ipz];
for i=2:5
    I_2(:,:,i)=[Iwx 0 0;0 Iwy 0;0 0 Iwx];
end
for i=6:9
    I_3(:,:,i)=[Irx 0 0;0 Iry 0;0 0 Irx];
end
%
%******************Calculate Inertia Forces and Moments********************
%                       RI(Vector , BodyNumber)
%                       MI(Vector , BodyNumber)
%
for i=1:9
    R_I_2(:,i)=-M(i)*a_2(:,i);
end
for i=1:5
    M_I_2(:,i)=-simplify(I_2(:,:,i)*DW_2and3(:,i)+cross(W_2(:,1),I_2(:,:,i)*W_2(:,i)));
end
for i=6:9
    R3_2=[cos(Phi_rol(i-5)) -sin(Phi_rol(i-5)) 0;sin(Phi_rol(i-5)) cos(Phi_rol(i-5)) 0;0 0 1];
    M_I_2(:,i)=-simplify(R3_2*(I_3(:,:,i)*DW_2and3(:,i))+cross(W_2(:,1),R3_2*(I_3(:,:,i)*R2_3*W_2(:,i))));
end
%******************Calculate Active Forces and Moments*********************
%                       RA(Vector , BodyNumber)
%                       MA(Vector , BodyNumber)
%
for i=1:9
    R_A_2(:,i)=[0;0;0];
    M_A_2(:,i)=[0;0;0];
end
T=[T1 T2 T3 T4];
Muf=[Muf1 Muf2 Muf3 Muf4];
for i=1:4
    M_par_2(:,i)=[0;T(i);0];
    M_par_2(:,i)=M_par_2(:,i)+[0;-Muf(i)*W_rel_2(2,i);0];
end
%*****************Calculate Generalized Inertia Forces*********************
%                     FI(Generalized Velocity Number)
Sum=0;
for j=1:3
    for i=1:9
        Sum=Sum+simplify(dot(R_I_2(:,i),V_par_2(:,i,j))+dot(M_I_2(:,i),W_par_2(:,i,j)));
    end
    FI(j)=Sum;
    Sum=0;
end
%******************Calculate Generalized Active Forces*********************
%                     F(Generalized Velocity Number)
Sum=0;
for j=1:3
    for i=1:4
        Sum=Sum+simplify(dot(M_par_2(:,i),W_rel_par_2(:,i,j)));
    end
    F(j)=Sum;
    Sum=0;
end
%*****************************Kane's Equations*****************************
% 
for i=1:3
    Equation(i)=simplify(F(i)+FI(i));
end
%
D2U=[D2X;D2Y;D2Beta];
clear Answer
Answer=solve(Equation,D2U);
D2Q=[simplify(Answer.D2X);simplify(Answer.D2Y);simplify(Answer.D2Beta)];
%
%********Write Robot Differential Equations in .m File Plant.m**********
%
FileNum=fopen('PlantWithFriction.m','w+');
fprintf(FileNum,'%s','function Dq=PlantWithFriction(tt,q,U)');
fprintf(FileNum,'\n%s','X=q(1);Y=q(2);Beta=q(3);DX=q(4);DY=q(5);DBeta=q(6);');
fprintf(FileNum,'\n%s','Mp=RobotParameters(1);Mw=RobotParameters(2);Mr=RobotParameters(3);H=RobotParameters(4);');
fprintf(FileNum,'\n%s','%');
fprintf(FileNum,'\n%s','L=RobotParameters(5);Rwheel=RobotParameters(6);Rrol=RobotParameters(7);Phi=RobotParameters(8);');
fprintf(FileNum,'\n%s','Ipx=RobotParameters(9);Ipxy=RobotParameters(10);Ipxz=RobotParameters(11);Ipy=RobotParameters(12);');
fprintf(FileNum,'\n%s','Ipyz=RobotParameters(13);Ipz=RobotParameters(14);Iwx=RobotParameters(15);Iwy=RobotParameters(16);');
fprintf(FileNum,'\n%s','Irx=RobotParameters(17);Iry=RobotParameters(18);');
fprintf(FileNum,'\n%s','Muf1=.1;Muf2=.15;Muf3=.2;Muf4=.05;');
fprintf(FileNum,'\n%s','T1=U(1);T2=U(2);T3=U(3);T4=U(4);');
fprintf(FileNum,'\n%s','%');
fprintf(FileNum,'\n%s','D2X=');
fprintf(FileNum,'%s',char(D2Q(1)));
fprintf(FileNum,'%s',';');
fprintf(FileNum,'\n%s','D2Y=');
fprintf(FileNum,'%s',char(D2Q(2)));
fprintf(FileNum,'%s',';');
fprintf(FileNum,'\n%s','D2Beta=');
fprintf(FileNum,'%s',char(D2Q(3)));
fprintf(FileNum,'%s',';');
fprintf(FileNum,'\n%s','Dq=[DX;DY;DBeta;D2X;D2Y;D2Beta];');
fclose(FileNum);
clear fileNum

    

