function PlotOffline(t,Xr,Po0,Vo,No,Ro,Rsafe,Rr,L,H,CaseNumber,Xd,Delta,RefreshRate,ShowSafeRegion,TakeSnapShot)
Color=[rand(No,1) zeros(No,1) rand(No,1)];
if CaseNumber==2
    xl1=0:.05:5;
    yl1min=-1/5*xl1+1;
    yl1max=5*ones(1,length(xl1));
    yl2=1:.05:5;
    xl2=zeros(1,length(yl2));
    yl3=0:.05:5;
    xl3=6-sqrt(2.7^2-(yl3-2.5).^2);
    Xmin=0;Xmax=5;Ymin=0;Ymax=5;
elseif CaseNumber==1
    xl1=-.35:.01:3.4;
    yl1=-.35*ones(1,length(xl1));
    yl2=3.4*ones(1,length(xl1));
    yl3=-.35:.01:3.4;
    xl2=-.35*ones(1,length(yl3));
    xl3=3.4*ones(1,length(yl3));
    Xmin=-.35;Xmax=3.4;Ymin=-.35;Ymax=3.4;
elseif CaseNumber==3
    xl1=-.2:.01:3.1;
    yl1=-.2*ones(1,length(xl1));
    yl2=2.2*ones(1,length(xl1));
    yl3=-.2:.01:2.2;
    xl2=-.2*ones(1,length(yl3));
    xl3=3.1*ones(1,length(yl3));
    Xmin=-.2;Xmax=3.1;Ymin=-.2;Ymax=2.2;
end
Index=0;
for k=1:fix(RefreshRate*length(t)):length(t)
    if TakeSnapShot==true
        Index=Index+1;
        try
        subplot(2,4,Index);
        catch
            Index=8;
            hold off
            subplot(2,4,Index);
        end
    else 
        clf('reset');
    end
    Pobs=Po0+t(k).*Vo;
    tt=0:.01:2*pi;
    for i=1:No
        grid on
        if Pobs(i,1)+Ro(i)>=Xmin && Pobs(i,2)+Ro(i)>=Ymin && Pobs(i,1)-Ro(i)<=Xmax && Pobs(i,2)-Ro(i)<=Ymax
            grid on
            xx=Pobs(i,1)+Ro(i)*cos(tt);
            yy=Pobs(i,2)+Ro(i)*sin(tt);
            xxs=Pobs(i,1)+(Ro(i)+Rsafe)*cos(tt);
            yys=Pobs(i,2)+(Ro(i)+Rsafe)*sin(tt);
            plot(xx,yy,'red')
            if norm(Pobs(i,:)-Xr(k,1:2))-Ro(i)-Rr>=Delta
                fill(xx,yy,[1,1,1],'FaceColor','yellow','EdgeColor','blue');
            else
                fill(xx,yy,[1,1,1],'FaceColor',Color(i,:),'EdgeColor','blue');
            end
            text(Pobs(i,1)-.07,Pobs(i,2)+.02,num2str(i),'Fontsize',11,'FontWeight','bold','FontName','Times New Roman');
            hold on
            grid on
            hold on 
        end
    end
    if CaseNumber==2
        plot(xl1,yl1min,'black','LineWidth',2);
        plot(xl1,yl1max,'black','LineWidth',2);
        plot(xl2,yl2,'black','LineWidth',2);
        plot(xl3,yl3,'black','LineWidth',2);
    elseif CaseNumber==1
        plot(xl1,[yl1;yl2],'black','LineWidth',2);
        plot(xl2,yl3,'black','LineWidth',2);
        plot(xl3,yl3,'black','LineWidth',2);
    elseif CaseNumber==3
        plot(xl1,[yl1;yl2],'black','LineWidth',2);
        plot(xl2,yl3,'black','LineWidth',2);
        plot(xl3,yl3,'black','LineWidth',2);
    end
    hold on
    plot(Xr(1:k,1),Xr(1:k,2),'black');
    grid on
    hold on
    DrawRobot(Xr(k,1),Xr(k,2),Xr(k,3),2*L,2*H,Rsafe,ShowSafeRegion);
    grid on
    xxd=.02*cos(tt)+Xd(1);
    yyd=.02*sin(tt)+Xd(2);
    plot(xxd,yyd,'green')
    fill(xxd,yyd,[1,1,1],'FaceColor','red','EdgeColor','black');
    title(['t= ',num2str(t(k)),' (s)'])
    drawnow;
    Ax=gca;
    Ax.FontSize=10;
    Ax.FontName='Times New Roman';
    Ax.FontWeight='bold';
    xlabel('x (m)','Fontsize',12,'FontWeight','bold','FontName','Times New Roman');
    ylabel('y (m)','Fontsize',12,'FontWeight','bold','FontName','Times New Roman');
    if CaseNumber==2
        axis([-.1 5.1 -.1 5.1]);
    elseif CaseNumber==1
        axis([-.45 3.5 -.45 3.5]);
    elseif CaseNumber==3
        axis([-.3 3.2 -.3 2.3]);
    end
end
end


