clear
clc
m=4;
n=3;
Umax=1;
Vmax=1.4;
amax=5.7;
%
%
Mp=4;Mw=1;Mr=.2;H=.1;L=.15;Rwheel=.07;Rrol=.01;Phi=45*pi/180;Ipx=.01;Ipxy=.001;Ipxz=.001;Ipy=.02;Ipyz=.001;Ipz=.17;Iwx=13e-4;Iwy=25e-4;Irx=1e-5;Iry=3e-5;
Muf1=.05;Muf2=.05;Muf3=.05;Muf4=.05;Rr=sqrt(L^2+H^2);Delta=.6;d1=.05;d2=.3;
RobotParameters=[Mp;Mw;Mr;H;L;Rwheel;Rrol;Phi;Ipx;Ipxy;Ipxz;Ipy;Ipyz;Ipz;Iwx;Iwy;Irx;Iry;Muf1;Muf2;Muf3;Muf4];
%
%
CaseNumber=input('Entaer Case Number: ');
switch CaseNumber
    case 1
        X0=[3 3 pi/4 0 0 0]';
        Xd=[0 0 pi/2+pi/6 0 0 0]';
        Po=[1.5 1.5;2.3 .6;.8 2.5;2.25 1];
        Vo=[0 0;-.5 0;0 -.27;0 .4];
        Ro=[.2;.2;.15;.15];
        Nu=7;
        tf=9;
        Dt=.1;
    case 2
        X0=[1 4.5 pi 0 0 0]';
        Xd=[3.5 .65 pi/2 0 0 0]';
        Nu=7;
        tf=8;
        Dt=.05;
        Po=[.4 3;1 3;1.5 3;2 3;2.5 3;3.1 1;3 4.3];
        Ro=[.27;.2;.2;.2;.2;.13;.18];
        Vo=[0 0;0 0;0 0;0 0;0 0;0 .5;-.4 -.3];
    case 3    %******************* Comparison ********************
        Umax=.211;
        X0=[.65 .1 .697 0 0 0]';
        Xd=[2.8 1.9 0 0 0 0]';
        Nu=7;
        tf=10;
        Dt=.1;
        Po=[2.1 .15;1.8 1.1;2.2 2.4];
        Ro=[.12;.12;.12];
        Vo=[-.3698 .3060;0 0;-.1445 -.2629];
        Vmax=.62;
        Delta=1;
        Muf1=.0238;Muf2=.0238;Muf3=.0238;Muf4=.0238;
        RobotParameters=[Mp;Mw;Mr;H;L;Rwheel;Rrol;Phi;Ipx;Ipxy;Ipxz;Ipy;Ipyz;Ipz;Iwx;Iwy;Irx;Iry;Muf1;Muf2;Muf3;Muf4];
end
Rsafe=Vmax*Dt;
Rsafe_wall=-amax*Dt^2+Vmax*Dt+.02;
Rsafe_wall=Rsafe;
No=length(Ro);
%
%
MPC=ModelPredictiveControl(n,m,Nu,tf,Dt,X0,Xd,Umax,Po,Vo,Ro,Rr,No,Rsafe,Rsafe_wall,Delta,d1,d2,RobotParameters,CaseNumber);
subplot(2,2,1)
plot(MPC{2},MPC{3})
xlabel('Time (s)');
ylabel('State Variables');
title('Time - State Variables');
grid on
hold on
subplot(2,2,2)
plot(MPC{2},MPC{3}(:,1:2))
xlabel('Time (s)');
ylabel('Position (m)');
title('Time - Position');
grid on
hold on
subplot(2,2,3)
plot(MPC{3}(:,1),MPC{3}(:,2),'black')
xlabel('X (m)');
ylabel('Y (m)');
title('Position Trajectory');
grid on
hold on
%************************************************
n=length(MPC{3}(:,1));
for i=1:150:n
    Px=MPC{3}(i,1);
    Py=MPC{3}(i,2);
    Pteta=MPC{3}(i,3);
    DrawRobot(Px,Py,Pteta,.3,.2,Rsafe,1);
    hold on
end
%************************************************
subplot(2,2,4)
plot(MPC{2},MPC{6})
xlabel('Time (s)');
ylabel('Errors ');
title('Time - Error');
grid on
%************************************************
pause
Path_Length=PathLength(MPC{3}(:,1),MPC{3}(:,2));
disp(['Length of Trajectory: ',num2str(Path_Length),' (m)']);
hold off
PlotOffline(MPC{2},MPC{3}(:,1:3),Po,Vo,No,Ro,Rsafe,Rr,L,H,CaseNumber,Xd,Delta,.008,true,false)

